#include "head.h"

int rdReg64(u32 Addr, unsigned char *rd_data)
{
	u8   recvBuf[32] = {0};
	u8   sendBuf[32] = {0};

	u32 ULData = 0;
	int i,len=sizeof(servaddr);
	
	sendBuf[0] = 0x80;	 //read;
	sendBuf[1] = 0x00;	 //don't care;
	sendBuf[2] = (Addr>>8 & 0xFF); //(address msb first);
	sendBuf[3] = (Addr &0xFF);

    if(sendto(sockfd,sendBuf,22,0,(struct sockaddr *)&servaddr,len) < 0){
       // printf("rdReg64: sendto is fail!\n");
        return -1;
    }

    if(recvfrom(sockfd,recvBuf,22,0,(struct sockaddr *)&servaddr,&len) < 0){
       // printf("rdReg64: recvfrom is fail!\n");
        return -1;
    }
	for(i=0;i<8;i++)
		{ rd_data[i] = recvBuf[4+i];}
	if((recvBuf[1]& 0xff) != 0x88) //check ACK;
		{
            //printf("READ Reg64, ACK errori!\n ");
          return -1;
        }
	return 0;
}

int  wrReg64(u32 Addr, unsigned char *wt_data)
{
	u8   recvBuf[32];
	u8   sendBuf[32];
    
	int len=sizeof(servaddr);
	
	sendBuf[0] = 0x00;  //write;
	sendBuf[1] = 0x00;  //don't care;
	sendBuf[2] = (Addr>>8 & 0xFF); //(address16 msb first);
	sendBuf[3] = (Addr &0xFF);
	
	sendBuf[4] = wt_data[0];
	sendBuf[5] = wt_data[1];
	sendBuf[6] = wt_data[2];
	sendBuf[7] = wt_data[3];
	sendBuf[8] = wt_data[4];
	sendBuf[9] = wt_data[5];
	sendBuf[10] = wt_data[6];
	sendBuf[11] = wt_data[7];

    if (sendto(sockfd,sendBuf,18,0,(struct sockaddr *)&servaddr,len) < 0){
     //   printf("WRReg64: sendto is fail!\n");
        return -1;
    }

    if (recvfrom(sockfd,recvBuf,18,0,(struct sockaddr *)&servaddr,&len) < 0){
        printf("WRReg64: recvfrom is fail!\n");
        return -1;
    }
	if((recvBuf[1]& 0xff) != 0x88)
		{// printf("WRITE Reg64, ACK error!\n ");
          return -1;
        }  
	return 0;
	
}

u8 host_controled_by()
{
	u8 tmpbuf[8];

	rdReg64((UDP_CONTROL_ADDR+CONTROL_RELEASE),tmpbuf);
	if(tmpbuf[0]==0)
        ;
	//	printf("host controled by udp_cmd !\n");
	else if(tmpbuf[0]==1);
	//	printf("host controled by mcu!\n");
    else {
		//printf("[host_controled_by] error!  rd invalid data!\n");
    }
	return tmpbuf[0];
}
int check_task_start()
{
	u8 i, tmpbuf[8],  ttimes = 0;
	do
	{
		rdReg64((UDP_CONTROL_ADDR+WORK_FINISHED),tmpbuf);
		if(tmpbuf[0]==1)
			usleep(1000);
		ttimes++;
	}while((ttimes<20)&&(tmpbuf[0]==1));

	if(ttimes==20)
	{
		wrReg64((UDP_CONTROL_ADDR+UDP_RELEASE),tmpbuf);
       // printf("check_task_start:time out.host work done or can't recevice command!\n");
		return -1;
	}
	else
	{
		wrReg64((UDP_CONTROL_ADDR+UDP_RELEASE),tmpbuf);
	}
	return 0;
}

int  check_task_done()
{
	int i;
	u8 tmpbuf[8],  ttimes = 0;
	do
	{
		rdReg64((UDP_CONTROL_ADDR+WORK_FINISHED),tmpbuf);
		if(tmpbuf[0]!=1)
			usleep(30000);
		ttimes++;
	}while((ttimes<200)&&(tmpbuf[0]!=1));


	if(ttimes==200)
	{
		printf("check_task_done : time out, host busy ! ");
		return -1;
	}
	return 0;
}


//--------------------------------------------------------------------------------------------
//		set_reset_host

//     reset host;

//-------------------------------------------------------------------------------------------

int  set_reset_host()
{
	u8 tmpbuffer[8]={0};

	udp_write_to_external_ram(MCU_SOFT_RESET*256,0, tmpbuffer);
    
	check_task_start();
	check_task_done();
	wrReg64((UDP_CONTROL_ADDR+UDP_RELEASE),tmpbuffer);
	return 0;
}


int  set_reset_host_1()
{
	u8 tmpbuffer[8]={0};

	udp_write_to_external_ram(MCU_SOFT_RESET*256,0, tmpbuffer);
    

	return 0;

}
//--------------------------------------------------------------------------------------------
//udp_read_from_external_ram
//addrReg    32 bit address;
//RegData	 64 bit data;
//--------------------------------------------------------------------------------------------
int udp_read_from_external_ram(u16 read_mode, u32 reg_addr, u8 *RegData)
{
	u8 tmpbuf[8];
		
	//read cmd, cs =0;
	tmpbuf[0] = 0X80;  //read;
	
	tmpbuf[2] = (u8)(read_mode & 0xff); 	//type;
	tmpbuf[1] = (u8)(read_mode>>8 &0xff);  //num; 
	
	tmpbuf[7] = (u8)(reg_addr &0xFF);	 //( data32  lsb first);
	tmpbuf[6] = (u8)(reg_addr>>8 & 0xFF);
	tmpbuf[5] = (u8)(reg_addr>>16 & 0xFF);
	tmpbuf[4] = (u8)(reg_addr>>24 & 0xFF);
   if(wrReg64((UDP_CONTROL_ADDR+UDP_CONTROL),tmpbuf)<0)
       return -1;
	
   if(check_task_start() < 0)
       return -1;
   if(check_task_done() < 0)
       return -1;

   if(rdReg64((UDP_CONTROL_ADDR+UDP_RD64),RegData)<0)
        return -1;

	//finished, cs =1;
   if(wrReg64((UDP_CONTROL_ADDR+UDP_RELEASE),tmpbuf)<0)
        return -1;

	return 0;
}

//--------------------------------------------------------------------------------------------
//		udp_write_to_external_ram


//addrReg    32 bit address;
//RegData	 64 bit data;
//--------------------------------------------------------------------------------------------
int udp_write_to_external_ram(u16 write_mode, u32 reg_addr, u8 *RegData)
{
	u8 tmpbuf[8];
		
	//send 64 bit data;
	if(wrReg64((UDP_CONTROL_ADDR+UDP_DATA64),RegData) < 0)
        return -1;

	//write cmd, cs =0;
	tmpbuf[0] = 0;  //write;
	
	tmpbuf[2] = (u8)(write_mode & 0xff); 	//type;
	tmpbuf[1] = (u8)(write_mode>>8 &0xff);  //num; 
	
	tmpbuf[7] = (u8)(reg_addr &0xFF);	 //( data32  lsb first);
	tmpbuf[6] = (u8)(reg_addr>>8 & 0xFF);
	tmpbuf[5] = (u8)(reg_addr>>16 & 0xFF);
	tmpbuf[4] = (u8)(reg_addr>>24 & 0xFF);
	if(wrReg64((UDP_CONTROL_ADDR+UDP_CONTROL),tmpbuf)< 0)
        return -1;
	
	if(check_task_start() < 0)
        return -1;
	if(check_task_done() < 0)
        return -1;

	//finished, cs =1;
	if(wrReg64((UDP_CONTROL_ADDR+UDP_RELEASE),tmpbuf) < 0)
        return -1;

	return 0;
}


//--------------------------------------------------------------------------------------------
//		read_24cxx


//reg_addr    16 bit address;
//length      16bit;
//databuff	  *p;
//--------------------------------------------------------------------------------------------

int read_24cxx(u16 reg_addr, u16 length, u8 *databuff)
{
	u8 tmpbuf[2];
	u16 wt_mode,i,j,k, x8byte, less_8bytes;
	u32 tmp_addr;

	less_8bytes = length&7;
	x8byte = length>>3;

	//first frame;
	if(less_8bytes == 0)
	{
		less_8bytes = 8;
		x8byte -=1;
	}
	tmpbuf[0] = less_8bytes;
	tmpbuf[1] = MCU_24CXX; 
	wt_mode = ((tmpbuf[1]<<8)|tmpbuf[0]);

	tmp_addr = (u32)reg_addr;
	udp_read_from_external_ram(wt_mode, tmp_addr, databuff);

	if(x8byte != 0)
	{	
		i = reg_addr + less_8bytes;
		j = less_8bytes;
		for(k=0;k<x8byte;k++)
		{
			tmpbuf[0] = 8;
			tmpbuf[1] = MCU_24CXX; 
			wt_mode = ((tmpbuf[1]<<8)|tmpbuf[0]);
			tmp_addr = (u32)i;
			udp_read_from_external_ram(wt_mode, tmp_addr, &databuff[j]);
			i += 8;
			j += 8;
		}
	}
	return 0;
}



//--------------------------------------------------------------------------------------------
//		write_24cxx


//reg_addr    16 bit address;
//length      16bit;
//databuff	  *p;
//--------------------------------------------------------------------------------------------

int write_24cxx(u16 reg_addr, u16 length, u8 *databuff)
{
	u8 tmpbuf[2];
	u16 wt_mode,i,j,k, x8byte, less_8bytes;
	u32 tmp_addr;

	less_8bytes = length&7;
	x8byte = length>>3;

	//first frame;
	if(less_8bytes == 0)
	{
		less_8bytes = 8;
		x8byte -=1;
	}
	tmpbuf[0] = less_8bytes;
	tmpbuf[1] = MCU_24CXX; 
	wt_mode = ((tmpbuf[1]<<8)|tmpbuf[0]);

	tmp_addr = (u32)reg_addr;
	udp_write_to_external_ram(wt_mode, tmp_addr, databuff);

	if(x8byte != 0)
	{	
		i = reg_addr + less_8bytes;
		j = less_8bytes;
		for(k=0;k<x8byte;k++)
		{
			tmpbuf[0] = 8;
			tmpbuf[1] = MCU_24CXX; 
			wt_mode = ((tmpbuf[1]<<8)|tmpbuf[0]);
			tmp_addr = (u32)i;
			udp_write_to_external_ram(wt_mode, tmp_addr, &databuff[j]);
			i += 8;
			j += 8;
		}
	}
	return 0;
}
		
unsigned char spi_GetFlashID(unsigned char *flashID)
{
	unsigned char i, tmpbuf[16];
	
	tmpbuf[0] = 1; //active spi bus from "z"
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_ENABLE ),tmpbuf);

	//release from Deep Power-down mode:
	tmpbuf[0] = 0xab;  
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_NM_DATA ),tmpbuf);
	tmpbuf[0] = 0xe0;
	tmpbuf[1] = 0x10;
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_CONFIG ),tmpbuf);

	tmpbuf[0] = 0x9f;  //write one byte "read identification command" ;
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_NM_DATA ),tmpbuf);
	tmpbuf[0] = 0x80;	//cs high to low;
	tmpbuf[0] += 0x40;  //cs low to high;
	tmpbuf[0] += 0x20;  //write command;
	tmpbuf[0] += 0x10;  // read 3 bytes ID
	
	tmpbuf[1] = 0x10;   //just one byte command for writing;
	tmpbuf[1] += 0x03;   //read 3 bytes ID;
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_CONFIG ),tmpbuf);
	
	rdReg64(GPIO(GPIO_BASEADDRESS + SPI_RD_DATA ),tmpbuf);  
	for(i=0;i<3;i++)
		{flashID[i] = tmpbuf[i];}
	
	return 0;
}		
	

int spi_read32bit(unsigned char * addr24bit, u32 *data32bit)
{
	unsigned char i, tmpbuf[16];

	tmpbuf[0] = 0x03;  // read command ;
	tmpbuf[1] = addr24bit[0]; //read_address, msb first;
	tmpbuf[2] = addr24bit[1];
	tmpbuf[3] = addr24bit[2];
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_NM_DATA ),tmpbuf);
	
	tmpbuf[0] = 0xf0;	//cs low,cs high, write, read;	
	tmpbuf[1] = 0x40;	// 4 bytes command for writing;
    tmpbuf[1] += 0x04;	 //read 4 bytes data;
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_CONFIG ),tmpbuf);
	
	rdReg64(GPIO(GPIO_BASEADDRESS + SPI_RD_DATA ),tmpbuf); 

	*data32bit = *(u32*)&tmpbuf[0];	

	return 0;
}
	
	
unsigned char spi_ChipErase()
{
	unsigned char i, wip, tmpbuf[16];

	spi_WriteEnable();

	//Chip Erase:
	tmpbuf[0] = 0xc7;  
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_NM_DATA ),tmpbuf);
	tmpbuf[0] = 0xe0;
	tmpbuf[1] = 0x10;
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_CONFIG ),tmpbuf);
	
	sleep(13);
	
	return 0;
}


void spi_WriteEnable( )
{
	unsigned char tmpbuf[16];

	//write enable:
	tmpbuf[0] = 0x06;  
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_NM_DATA ),tmpbuf);
	tmpbuf[0] = 0xe0;
	tmpbuf[1] = 0x10;
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_CONFIG ),tmpbuf);
	
	return;
}

unsigned char spi_ChipEraseStatus()
{
	unsigned char wip, tmpbuf[4];

	tmpbuf[0] = spi_ReadChipStatus_S7_S0();
	wip = tmpbuf[0]&1;
	if(wip==0)
		return 1;
	else
	{
		printf("read status register0  %x\n",tmpbuf[0]);
		sleep(1);
		return 0;
	}
}

unsigned char spi_ReadChipStatus_S7_S0()
{
	unsigned char tmpbuf[16];
	tmpbuf[0] = 0x05;  
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_NM_DATA ),tmpbuf);
	tmpbuf[0] = 0xf0;
	tmpbuf[1] = 0x11;
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_CONFIG ),tmpbuf);
	rdReg64(GPIO(GPIO_BASEADDRESS + SPI_RD_DATA ),tmpbuf);  
	
	return tmpbuf[0];
}



int spi_Write1page(unsigned char * addr24bit, unsigned char *data256byte)
{
	unsigned char i,j, wip, tmpbuf[16];

	spi_WriteEnable();

	tmpbuf[0] = 0x02;  // PAGE PROGRAM;
	tmpbuf[1] = addr24bit[0]; //read_address, msb first;
	tmpbuf[2] = addr24bit[1];
	tmpbuf[3] = addr24bit[2];

	tmpbuf[4] = data256byte[0];
	tmpbuf[5] = data256byte[1];
	tmpbuf[6] = data256byte[2];
	tmpbuf[7] = data256byte[3];
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_WTFAST_START),tmpbuf);

	/*
	wrReg32( GPIO(GPIO_BASEADDRESS + SPI_COMMAND ), *(ULONG *)&tmpbuf[0]);
	wrReg32( GPIO(GPIO_BASEADDRESS + SPI_WT_DATA ), *(ULONG *)&data256byte[0]);

	tmpbuf[0] = 0xa0;	//cs low,cs high, write, no read;	
	tmpbuf[1] = 0x80;	// 4 bytes command & 2 bytes data for writing;
	wrReg32( GPIO(GPIO_BASEADDRESS + SPI_CONFIG ), *(ULONG *)&tmpbuf[0]); */

	for(j=0;j<31;j++)
	{
		tmpbuf[0] = data256byte[4+j*8 +0];
		tmpbuf[1] = data256byte[4+j*8 +1];
		tmpbuf[2] = data256byte[4+j*8 +2];
		tmpbuf[3] = data256byte[4+j*8 +3];
		tmpbuf[4] = data256byte[4+j*8 +4];
		tmpbuf[5] = data256byte[4+j*8 +5];
		tmpbuf[6] = data256byte[4+j*8 +6];
		tmpbuf[7] = data256byte[4+j*8 +7];

		wrReg64( GPIO(GPIO_BASEADDRESS + SPI_WTFAST_RUN),tmpbuf);
		
		/*
		wrReg32( GPIO(GPIO_BASEADDRESS + SPI_COMMAND ), *(ULONG *)&tmpbuf[0]);
		wrReg32( GPIO(GPIO_BASEADDRESS + SPI_WT_DATA ), *(ULONG *)&tmpbuf[4]);
		
		tmpbuf[0] = 0x20;	//cs low,cs high, write, no read;	
		tmpbuf[1] = 0x80;	// 4 bytes command & 2 bytes data for writing;
		wrReg32( GPIO(GPIO_BASEADDRESS + SPI_CONFIG ), *(ULONG *)&tmpbuf[0]);  */
	}

	tmpbuf[0] = data256byte[252];  
	tmpbuf[1] = data256byte[253];  
	tmpbuf[2] = data256byte[254];  
	tmpbuf[3] = data256byte[255];  

	/*
	wrReg32( GPIO(GPIO_BASEADDRESS + SPI_COMMAND ), *(ULONG *)&tmpbuf[0]);

	tmpbuf[0] = 0x60;	//cs low,cs high, write, no read;	
	tmpbuf[1] = 0x40;	// 4 bytes command & 2 bytes data for writing;
	wrReg32( GPIO(GPIO_BASEADDRESS + SPI_CONFIG ), *(ULONG *)&tmpbuf[0]);

	*/
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_WTFAST_END),tmpbuf);

	//read status register for WIP bit;
	wip = 1;
	for(i=0;(i<250)&wip;i++)
	{
		tmpbuf[0] = spi_ReadChipStatus_S7_S0();
		wip = tmpbuf[0]&1;
	}
	if(i==250)
	{
		printf("write 16 bit---------------------------------------------register");
		return -1;
	}
	return 0;
}


void spi_WriteDisable( )
{
	unsigned char tmpbuf[16];
	
	//write disable:
	tmpbuf[0] = 0x04;  
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_NM_DATA ),tmpbuf);
	tmpbuf[0] = 0xe0;
	tmpbuf[1] = 0x10;
	wrReg64( GPIO(GPIO_BASEADDRESS + SPI_CONFIG ),tmpbuf);
	
	return;
}



		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		
		

