#ifndef __HEAD_H_
#define __HEAD_H_

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <stdint.h>
#include <inttypes.h>
#include <stdbool.h>
#include <string.h>
#include <ctype.h>
#include <pthread.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <getopt.h>
#include <errno.h>
#include <fcntl.h>  
#include <string.h>  
#include <sys/types.h>  
#include <sys/stat.h>  
#include <linux/fs.h>
//#include <thread_mutex.c>

//#define   u8  unsigned char				/* Unsigned  8 bit quantity       */
//#define   u16 unsigned short					/* Unsigned 16 bit quantity       */
//#define   u32 unsigned int		

#define MAKEWORD(a,b)       ((u16)(a) | (u16)((b) << 8)) 
#define LOBYTE(w)           ((u8)((u16)(w) & 0x0ff)) 
#define HIBYTE(w)           ((u8)((u16)(w) & 0xff00 >> 8 )) 

// This is the highest internal RAM address for the AN2131Q
//
#define MAX_INTERNAL_ADDRESS        0x1B3F

#define INTERNAL_RAM(address) ((address <= MAX_INTERNAL_ADDRESS) ? 1 : 0)
//
// EZ-USB Control and Status Register.  Bit 0 controls 8051 reset
//
#define CPUCS_REG_EZUSB             0x7F92
#define CPUCS_REG_FX2               0xE600

#define CHUNK_SIZE                  64
#define  TS_BULK_READ_PIPE_NUM      0
//#define  BULK_TRANS_BUF_SIZE        51200//10240

#define TRANSPORT_PACKET_SIZE				188    
#define TRANSPORT_PACKET_COUNT				512  

typedef unsigned char		u8;				/* Unsigned  8 bit quantity       */
typedef unsigned short 		u16;			/* Unsigned 16 bit quantity       */
typedef unsigned int		u32;

#define SUCCESS				1
#define FAILURE				0	

#define DTUSB_BUFFER_LEN_PER_RECV	(8*1024)
#define AV_MEM_LEN	1024*1024

typedef struct _RING_MGR
{
	unsigned int max_len;
	unsigned int rp;
	unsigned int wp;
	int over_flag;
	unsigned char data[1];
}RING_MGR,*PRING_MGR;


///////////////////////ecp3////////////////////////////////

/**
 * Macros for specifying the address in a specific BAR address space.
 * to write to address 0x10 in BAR1 of the device use: BAR1(0x10)
 */

//I2C BLOCK;

#define G_IICAddressCul  0x1000

#define I2C3_BASEADDRESS  0x7000
#define I2C2_BASEADDRESS  0x6000
#define I2C1_BASEADDRESS  0x5000
#define I2C0_BASEADDRESS  0x1000

/*  i2c register */
#define I2C_STATUS     	 0x00  //read only;
#define DEMO_RST     	 0x08  //RW
#define I2C_COMMAND      0x10  //write only
#define I2C_R_DATA     	 0x10  //read only
#define UDP_DELAY		0x18
#define LNB_POWER		0x20
//==================================================================


#define PORT0_ADDR 					0x0080
#define TP0_ADDR					0x0000

#define TP0					0x0000
#define TP1					0x0001
#define TP2					0x0002
#define TP3					0x0003
#define TP4					0x0004
#define TP5					0x0005
#define TP6					0x0006
#define TP7					0x0007




#define PORT_POWER					0x00
#define PORT_POLARIZATION			0x01
#define PORT_22KHz					0x02
#define PORT_SAT_AB					0x03
#define PORT_DiSEqC					0x04   //0x04 ~0x0f



//base setting;
#define BASESET_BASEADDRESS  0x8000

//network asi out
#define MULTICAST_EN		  0x10
#define MULTICAST_IP        0x18
#define TS_IP_PORT          0x1c    //)网口接收TS数据专用的TS_IP_PORT. 不同于server_port. 写到24c02.  用户可以设置类型

#define SPI_SWITCH   0x0030  //spi_device: 0x0030 bit[56].  1: FPGA SPI flash,we need to do it before writing fpga spi;   0:GS2972 SPI




#define GPIO_BASEADDRESS 0x0000
#define DMA3_BASEADDRESS  0x8000
#define DMA2_BASEADDRESS  0x9000
#define DMA1_BASEADDRESS  0xa000
#define DMA0_BASEADDRESS  0xb000
#define INT_BASEADDRESS  0xc000



/* gpio register */
#define GPIO_3     	 0x00   //tunerA
#define GPIO_2     	 0x04   //tunerB
#define GPIO_1     	 0x08	//tunerC
#define GPIO_0     	 0x0c   //tunerD

#define GPIO_VERSION  0x20   //get FW version

#define GPIO_TESTTS     	 0x20   //set test TS for debug  
#define GPIO_TESTTSSPEED     	 0x24   // set TS speed


#define SPI_ENABLE       	 0x00
#define SPI_CONFIG      	 0x08
#define SPI_NM_DATA     	 0x10
#define SPI_WTFAST_START     0x18
#define SPI_WTFAST_RUN       0x20
#define SPI_WTFAST_END       0x28

#define SPI_STATUS      	 0x00
#define SPI_RD_DATA     	 0x08


#define I2C3_MASK		 0x08
#define I2C2_MASK		 0x0c
#define I2C1_MASK		 0x10
#define I2C0_MASK		 0x14
#define DMA3_MASK		 0x18
#define DMA2_MASK		 0x1C
#define DMA1_MASK		 0x20
#define DMA0_MASK		 0x24



/*  DMA register */
#define DMA_GO     	 0x00
#define DMA_STATUS     	 0x00
#define DMA_SIZE         0x04
#define ADDRESS0_HI      0x08
#define ADDRESS0_LOW     0x0c
#define DMA_CELLSIZE     0x10
#define DMA_GSSETTING    0x14
#define DMA_FIFODPC      0x18



/*  INT register */
#define INT_STATUS     	 0x00
#define INT_EN    	     0x04
#define INT_MASK         0x08  
#define INT_XXX			 0x0c


#define MAX_PCI_BARS 7

#define BAR0(a) (0x00000000 | a)
#define BAR1(a) (0x10000000 | a)
#define BAR2(a) (0x20000000 | a)
#define BAR3(a) (0x30000000 | a)
#define BAR4(a) (0x40000000 | a)
#define BAR5(a) (0x50000000 | a)
#define BAREXP(a) (0x60000000 | a)

#define OFFSET2BAR(o) (o>>28)
#define OFFSET2ADDR(o) (o & 0x0fffffff)

#define BARADDR2BAR(o) (o>>28)
#define BARADDR2OFFSET(o) (o & 0x0fffffff)
#define MAKE_BARADDR(n, o) ((n<<28) | (o & 0x0fffffff))

#define WB(a) (a & 0x0fffffff)   // convert the system (PC) resource addr to the board's local Address

#define MAX_RW_BLOCK_SIZE 4096   // Maximum number of bytes per block transfer operation

#define RTP0_FPGA_ADDR		0xc000  



//---------------------------------------------------

//write
#define SOURCE_SELECT 			0*8    //R/W
#define TARGET_IP_ADDR 			1*8    //R/W
#define TARGET_PORT 			2*8    //R/W
#define RTP_FUNCTION_ON 		3*8
#define PID_FILTER_EN			4*8
#define PID0_13BITX4			5*8
#define PID1_13BITX4			6*8
#define ALL_TS_PASS				7*8			
//read only:
#define TARGET_MAC_ADDR			3*8		
//---------------------------------------------------


typedef struct _RTP_PARAMETER
{
	bool rtp_gate;
	bool all_ts_through;
	unsigned char position;
	unsigned char ts_port;
	unsigned char pid_en[8];
	unsigned short udp_port;
	unsigned char ip_addr[4];
	unsigned short tv_pid[8];
}RTP_PARAMETER;




//24cxx (0x00 ~0x1f)
#define LOCAL_MAC_ADDR		0x00
#define LOCAL_IP_ADDR		0x08
#define LOCAL_PORT_ADDR 	0x0c

//24cxx (0x10 ~ 0xbf) rtp setting  RTP0_24CXX_ADDR +i*24
#define RTP0_24CXX_ADDR		0x10
#define RTP1_24CXX_ADDR		0x28
#define RTP2_24CXX_ADDR		0x40
#define RTP3_24CXX_ADDR		0x58
#define RTP4_24CXX_ADDR		0x70
#define RTP5_24CXX_ADDR		0x88
#define RTP6_24CXX_ADDR		0xa0
#define RTP7_24CXX_ADDR		0xb8


//define 4k mcu flash;
#define MCU_FLASH_SECTOR_0	0xe800
#define MCU_FLASH_SECTOR_1	0xea00
#define MCU_FLASH_SECTOR_2	0xec00
#define MCU_FLASH_SECTOR_3	0xee00
#define MCU_FLASH_SECTOR_4	0xf000
#define MCU_FLASH_SECTOR_5	0xf200
#define MCU_FLASH_SECTOR_6	0xf400
#define MCU_FLASH_SECTOR_7	0xf600

//---------------------------------------------------------------------------------------------------------------------
#define UDP_CONTROL_ADDR	0x4000
//write
#define UDP_CONTROL 			0*8    
#define UDP_DATA64 			    1*8   
#define UDP_RELEASE 			2*8 
//read
#define WORK_FINISHED 			0*8    
#define UDP_RD64 			    1*8   
#define CONTROL_RELEASE 		2*8 


#define BASESETTING_ADDR	0x8000
#define LOCAL_IP 			0*8    
#define LOCAL_MAC 			1*8    
#define SERVER_PORT 		2*8    

//#define TS_PORT 			3*8    
//#define MULTICAST_EN 		4*8    
//#define MULTICAST_IP 		5*8    

//---------------------------------------------------------------------------------------------------------------------
//TYPE
#define MCU_SOFT_RESET			0
#define FPGA_RELOAD 			1
#define EARSE_EEPROM_PAGE       2
#define EARSE_SPIFLASH_PAGE     3

#define CLOSE_ALL_RTPs   		4
#define SETTING_RF_PORT   		5
#define SETTING_TP   			6
#define SETTING_DEMO_RST   		7


#define MCU_EEPROM				8
#define MCU_24CXX 				9
#define MCU_SPI_FLASH 			10
#define SETTING_LNB_POWER		11
#define SETTING_H_V 			12
#define SETTING_22KHZ 			13

//---------------------------------------------------------------------------------------------------------------------
//===========================================================================================

#define TP0_ADDR 					0x0000

#define TP_GATE						0x00
#define TP_IF						0x01   //0x01~0x04
#define TP_SYMBOLRATE				0x05   //0x05~0x08
#define TP_H_V						0x09   
#define TP_22kHz					0x0a  

//------------------------------------------------------
//==============================================================
//   Memory Map of IP Modules in Demo design
// Used for lighting LED segments during driver State changes
// Basic Demo only has BAR1
// SFIF Demo maps BAR0 and BAR1 together, so BAR 1 is common
// to all demos then
//==============================================================
#define GPIO(i)     ((BAR0(0x0000)) + i)
#define SYS_MEM_BUF_SIZE 16384  // 16kB buffer = 1024*16
#define DMA_MEM_BUF_SIZE  4194304  //4M  //  2M = 1024*1024*2           //1048576   //16384  // 16kB buffer
#define DMA_TBS_SIZE 4194304    
#define DMA_CELL    48128      
#define CELL_NUM    8        //128x 47x 8
#define DMA_TOTAL   385024      
#define DMA_TOTAL2 	770048      //DMA_TOTAL *2 
#define DMA_TOTAL3	1155072      //DMA_TOTAL *3  
#define MAX_PCI_BARS 7
#define DbgLogInfo(x)	printf(x)


/*****************************************************************************************************/
extern int sockfd;
extern struct sockaddr_in servaddr;
//extern pthread_mutex_t mutex;

extern int write_24cxx(u16 reg_addr, u16 length, u8 *databuff);
extern int read_24cxx(u16 reg_addr, u16 length, u8 *databuff);
extern int udp_write_to_external_ram(u16 write_mode, u32 reg_addr, u8 *RegData);
extern int udp_read_from_external_ram(u16 read_mode, u32 reg_addr, u8 *RegData);
extern int set_reset_host();
extern int check_task_done();
extern int check_task_start();
extern u8 host_controled_by();
extern int wrReg64(u32 Addr, unsigned char *wt_data);
extern int  rdReg64(u32 Addr, unsigned char *rd_data);
extern int  set_reset_host_1();
extern unsigned char spi_GetFlashID(unsigned char *flashID);
extern int spi_read32bit(unsigned char * addr24bit, u32 *data32bit);
extern unsigned char spi_ChipErase();
extern void spi_WriteEnable( );
extern unsigned char spi_ChipEraseStatus();
extern unsigned char spi_ReadChipStatus_S7_S0();
extern int spi_Write1page(unsigned char * addr24bit, unsigned char *data256byte);
extern void spi_WriteDisable( );









/******************************************************************************************************/



#endif
